'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _shallowCompare = require('react/lib/shallowCompare');

var _shallowCompare2 = _interopRequireDefault(_shallowCompare);

var _highlight = require('highlight.js');

var _highlight2 = _interopRequireDefault(_highlight);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Highlight = function (_Component) {
  _inherits(Highlight, _Component);

  function Highlight() {
    var _temp, _this, _ret;

    _classCallCheck(this, Highlight);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      highlightedCode: null,
      language: null
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Highlight.prototype.componentDidMount = function componentDidMount() {
    this._highlightCode();
  };

  Highlight.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    return (0, _shallowCompare2.default)(this, nextProps, nextState);
  };

  Highlight.prototype.componentDidUpdate = function componentDidUpdate() {
    this._highlightCode();
  };

  // $FlowIssue - get/set properties not yet supported

  Highlight.prototype._highlightCode = function _highlightCode() {
    var _this2 = this;

    var promise = new Promise(this.highlightCallback);

    promise.then(function (result) {
      return _this2.setState({ highlightedCode: result.value, language: result.language });
    }).catch(function (error) {
      return console.error(error);
    });
  };

  Highlight.prototype.render = function render() {
    var code = this.state.highlightedCode;
    var classes = (0, _classnames2.default)(this.props.className, 'hljs', this.state.language);

    if (code) {
      return _react2.default.createElement(
        'pre',
        null,
        _react2.default.createElement('code', { className: classes, dangerouslySetInnerHTML: { __html: code } })
      );
    } else {
      return _react2.default.createElement(
        'pre',
        null,
        _react2.default.createElement(
          'code',
          { className: classes },
          this.initialCode
        )
      );
    }
  };

  _createClass(Highlight, [{
    key: 'initialCode',
    get: function get() {
      return this.props.children;
    }

    // $FlowIssue - get/set properties not yet supported

  }, {
    key: 'highlightCallback',
    get: function get() {
      var _this3 = this;

      var callback = undefined;

      if (this.props.languages && this.props.languages.length === 1) {
        (function () {
          var language = _this3.props.languages[0];
          callback = function callback(resolve) {
            return resolve(_highlight2.default.highlight(language, _this3.initialCode));
          };
        })();
      } else {
        callback = function callback(resolve) {
          return resolve(_highlight2.default.highlightAuto(_this3.initialCode, _this3.props.languages));
        };
      }

      return callback;
    }
  }]);

  return Highlight;
}(_react.Component);

exports.default = Highlight;